#include "settings.h"
#include "supinfo.h"
#include <tlhelp32.h>
#include <shlwapi.h>	//DLLVERSIONINFO

// win2kȍ~
#pragma comment(linker, "/subsystem:windows,5.0")

typedef struct _GDIPP_HOOKINFO {
	UINT	cbSize;
	DWORD	dwFlags;
} GDIPP_HOOKINFO;

#define GDIPPHF_REDRAWWINDOW	0x0001

typedef struct _GDIPP_SETTINGS {
	UINT	cbSize;
	BOOL	bReserved[10];
} GDIPP_SETTINGS;

typedef BOOL (CALLBACK FUNCTION_CALLBACK)(DWORD dwProcessId, HMODULE hModule);
BOOL WINAPI CallRemoteFunction(FUNCTION_CALLBACK pfn);
BOOL CALLBACK ApplyNewCallback(DWORD dwProcessId, HMODULE hModule);
BOOL CALLBACK _RemoteFreeLibraryCallback(DWORD dwProcessId, HMODULE hModule);


EXTERN_C LRESULT CALLBACK _GetMsgProc(int code, WPARAM wParam, LPARAM lParam)
{
	//Ȃ
	return CallNextHookEx(NULL, code, wParam, lParam);
}

EXTERN_C HRESULT WINAPI GdippDllGetVersion(DLLVERSIONINFO* pdvi)
{
	if (!pdvi || pdvi->cbSize < sizeof(DLLVERSIONINFO)) {
		return E_INVALIDARG;
	}

	const UINT cbSize = pdvi->cbSize;
	ZeroMemory(pdvi, cbSize);
	pdvi->cbSize = cbSize;

	HRSRC hRsrc = FindResource(GetDLLInstance(), MAKEINTRESOURCE(VS_VERSION_INFO), RT_VERSION);
	if (!hRsrc) {
		return E_FAIL;
	}

	HGLOBAL hGlobal = LoadResource(GetDLLInstance(), hRsrc);
	if (!hGlobal) {
		return E_FAIL;
	}

	const WORD* lpwPtr = (const WORD*)LockResource(hGlobal);
	if (lpwPtr[1] != sizeof(VS_FIXEDFILEINFO)) {
		return E_FAIL;
	}

	const VS_FIXEDFILEINFO* pvffi = (const VS_FIXEDFILEINFO*)(lpwPtr + 20);
	if (pvffi->dwSignature != VS_FFI_SIGNATURE ||
			pvffi->dwStrucVersion != VS_FFI_STRUCVERSION) {
		return E_FAIL;
	}

	//8.0.2006.1027
	// -> Major: 8, Minor: 2006, Build: 1027
	pdvi->dwMajorVersion	= HIWORD(pvffi->dwFileVersionMS);
	pdvi->dwMinorVersion	= LOWORD(pvffi->dwFileVersionMS) * 10 + HIWORD(pvffi->dwFileVersionLS);
	pdvi->dwBuildNumber		= LOWORD(pvffi->dwFileVersionLS);
	pdvi->dwPlatformID		= DLLVER_PLATFORM_NT;

	if (pdvi->cbSize < sizeof(DLLVERSIONINFO2)) {
		return S_OK;
	}

	DLLVERSIONINFO2* pdvi2 = (DLLVERSIONINFO2*)pdvi;
	pdvi2->ullVersion		= MAKEDLLVERULL(pdvi->dwMajorVersion, pdvi->dwMinorVersion, pdvi->dwBuildNumber, 2);
	return S_OK;
}

#if 0
EXTERN_C HHOOK WINAPI GdippInstallHook(GDIPP_HOOKINFO* pInfo)
{
	if (!pInfo || pInfo->cbSize < sizeof(GDIPP_HOOKINFO)) {
		return NULL;
	}
	HHOOK hhk = SetWindowsHookEx(WH_GETMESSAGE, GetMsgProc, GetDLLInstance(), 0);
	if (hhk) {
		PostMessage(HWND_BROADCAST, WM_NULL, 0, 0);
		if (pInfo->dwFlags & GDIPPHF_REDRAWWINDOW) {
			RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
		}
	}
	return hhk;
}

EXTERN_C BOOL WINAPI GdippRemoveHook(HHOOK hhk, GDIPP_HOOKINFO* pInfo)
{
	if (!pInfo || pInfo->cbSize < sizeof(GDIPP_HOOKINFO)) {
		return NULL;
	}
	BOOL bRet = UnhookWindowsHookEx(hhk);
	if (bRet) {
		PostMessage(HWND_BROADCAST, WM_NULL, 0, 0);
		if (pInfo->dwFlags & GDIPPHF_REDRAWWINDOW) {
			RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
		}
	}
	return bRet;
}

EXTERN_C BOOL WINAPI GdippUnloadALL()
{
	if (CallRemoteFunction(_RemoteFreeLibraryCallback)) {
		RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
		return TRUE;
	}
	return FALSE;
}

//܂΍􂪏oĂȂ̂ňꎞIɎgps
EXTERN_C BOOL WINAPI GdippApplyNewSettings(const GDIPP_SETTINGS* pSettings)
{
	return FALSE;
/*	if (pSettings && pSettings->cbSize < sizeof(GDIPP_SETTINGS)) {
		return FALSE;
	}
	SetLastError(0);
	return g_pSettings->LoadSettings();*/
}

EXTERN_C BOOL WINAPI GdippApplyNewSettingsToALL(const GDIPP_SETTINGS* pSettings)
{
	return FALSE;
/*	if (pSettings && pSettings->cbSize < sizeof(GDIPP_SETTINGS)) {
		return FALSE;
	}
	LockWindowUpdate(GetDesktopWindow());
	BOOL ret = CallRemoteFunction(ApplyNewCallback);
	LockWindowUpdate(NULL);
	if (ret) {
		RedrawWindow(GetDesktopWindow(), NULL, NULL, RDW_INVALIDATE | RDW_ERASE | RDW_ALLCHILDREN);
	}
	return ret;*/
}

BOOL CALLBACK ApplyNewCallback(DWORD dwProcessId, HMODULE hModule)
{
	HANDLE hProcess = OpenProcess(PROCESS_CREATE_THREAD | PROCESS_QUERY_INFORMATION |
									PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ,
									TRUE, dwProcessId);
	if (!hProcess) {
		return FALSE;
	}

	DWORD ret = 0;
	DWORD dwThreadId;
	HANDLE hThread;
	LPBYTE pfn = (LPBYTE)GdippApplyNewSettings - (LPBYTE)GetDLLInstance() + (LPBYTE)hModule;

	hThread = CreateRemoteThread(hProcess, NULL, 0,
								(LPTHREAD_START_ROUTINE)pfn,
								NULL, 0, &dwThreadId);

	if (hThread) {
		WaitForSingleObject(hThread, INFINITE);
		GetExitCodeThread(hThread, &ret);
		CloseHandle(hThread);
	}

	CloseHandle(hProcess);
	return ret;
}

inline
BOOL WINAPI _RemoteFreeLibrary(DWORD dwProcessId, HMODULE hModule, BOOL bForceUnload)
{
	HANDLE hProcess = OpenProcess(PROCESS_CREATE_THREAD | PROCESS_QUERY_INFORMATION |
									PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ,
									TRUE, dwProcessId);
	if (!hProcess) {
		return FALSE;
	}

	DWORD ret = 0;
	DWORD dwThreadId;
	HANDLE hThread;

	for (;;) {
		hThread = CreateRemoteThread(hProcess, NULL, 0,
									(LPTHREAD_START_ROUTINE)FreeLibrary,
									hModule, 0, &dwThreadId);

		if(!hThread) {
			ret = FALSE;
			break;
		}

		WaitForSingleObject(hThread, INFINITE);
		GetExitCodeThread(hThread, &ret);
		CloseHandle(hThread);

		if(!bForceUnload) {
			break;
		} else if(!ret) {
			ret = TRUE;
			break;
		}
	}

	CloseHandle(hProcess);
	return ret;
}

BOOL CALLBACK _RemoteFreeLibraryCallback(DWORD dwProcessId, HMODULE hModule)
{
	return _RemoteFreeLibrary(dwProcessId, hModule, TRUE);
}

BOOL WINAPI CallRemoteFunction(FUNCTION_CALLBACK pfn)
{
	HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
	if(hSnapshot == INVALID_HANDLE_VALUE) {
		return FALSE;
	}

	DWORD dwMyProcessId = GetCurrentProcessId();
	PROCESSENTRY32 pe = { sizeof(PROCESSENTRY32) };
	SetLastError(0);
	BOOL ret = Process32First(hSnapshot, &pe);

	while(ret && GetLastError() != ERROR_NO_MORE_FILES) {
		if(pe.th32ProcessID != dwMyProcessId) {
			HANDLE hSnapModule = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pe.th32ProcessID);
			if(hSnapModule != INVALID_HANDLE_VALUE) {
				MODULEENTRY32 me = { sizeof(MODULEENTRY32) };
				ret = Module32First(hSnapModule, &me);
				while(ret && GetLastError() != ERROR_NO_MORE_FILES) {
//					MessageBox(NULL, me.szExePath, me.szModule, MB_OK);
					if(_tcsicmp(me.szModule, _T("gdi++.dll")) == 0) {
						pfn(pe.th32ProcessID, me.hModule);
					}
					SetLastError(0);
					ret = Module32Next(hSnapModule, &me);
				}
				CloseHandle(hSnapModule);
			}
		}
		SetLastError(0);
		ret = Process32Next(hSnapshot, &pe);
	}
	CloseHandle(hSnapshot);
	return TRUE;
}
#endif

//ȉrun.cppRs[

static void errmsg(LPCWSTR format, ...)
{
	WCHAR  buffer [1024];
	va_list val;
	va_start(val, format);
	_vsnwprintf(buffer, 1024, format, val);
	va_end(val);
	MessageBox(NULL, buffer, L"gdi++ ERROR", MB_OK|MB_ICONSTOP);
}

// EXEt@C(PE)̃wb_[ǂ݁A
// Gg|Cg̃AhXԂ
static LPVOID get_entrypoint(LPCWSTR path)
{
	LPVOID entrypoint = NULL;
	DWORD len;
	IMAGE_DOS_HEADER dos;
	IMAGE_NT_HEADERS pe;
	HANDLE file = CreateFile(path, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if(file == INVALID_HANDLE_VALUE) {
//		errmsg(L"t@CJ܂.\n%s", path);
	}
	else if(!ReadFile(file, &dos, sizeof(dos), &len, NULL) ||
		dos.e_magic != IMAGE_DOS_SIGNATURE ||
		!SetFilePointer(file, dos.e_lfanew, NULL, FILE_BEGIN) ||
		!ReadFile(file, &pe, sizeof(pe), &len, NULL) ||
		pe.Signature != IMAGE_NT_SIGNATURE) {
//		errmsg(L"EXEt@Cł͂Ȃ.\n%s", path);
	}
	else {
		#pragma warning(push)
		#pragma warning(disable:4312)
		entrypoint = (LPVOID)(pe.OptionalHeader.ImageBase + pe.OptionalHeader.AddressOfEntryPoint);
		#pragma warning(pop)
	}
	if(file != INVALID_HANDLE_VALUE)
		CloseHandle(file);
	return entrypoint;
}

// ~߂ĂvZX̃Gg|CgALoadLibrary
EXTERN_C BOOL WINAPI GdippInjectDLL(HANDLE process, LPCWSTR app)
{
	LPVOID entrypoint = get_entrypoint(app);
	if (!entrypoint) {
		return false;
	}

	// gdi++.dll̃pX
	WCHAR dllpath [MAX_PATH];
	GetModuleFileName(GetDLLInstance(), dllpath, MAX_PATH);
//	UINT len = GetModuleFileName(NULL, dllpath, MAX_PATH);
//	wcscpy(dllpath+len-4, L".dll");

	//EntryPoint opcode2jmp
	BYTE opcode1 [8] = {
		0xB8,0,0,0,0,	// mov  eax, 00000000h
		0xFF,0xE0,	// jmp  eax
		0xCC,		// int  3
	};
	//EntryPoint߂ LoadLibrary EntryPointjmp
	BYTE  opcode2 [32+16+sizeof(dllpath)] = {
		0x8B, 0x48, 0x24,	// mov  ecx, dword ptr [eax+36]
		0x8B, 0x50, 0x28,	// mov  edx, dword ptr [eax+40]
		0x89, 0x11,		// mov  dword ptr [ecx+0], edx
		0x8B, 0x50, 0x2C,	// mov  edx, dword ptr [eax+44]
		0x89, 0x51, 0x04,	// mov  dword ptr [ecx+4], edx
		0x51,			// push ecx
		0x8B, 0xD0,		// mov  edx, eax
		0x83, 0xC2, 0x30,	// add  edx, 48
		0x52,			// push edx
		0xFF, 0x50, 0x20,	// call dword ptr [eax+32]
		0x59,			// pop  ecx
		0xFF, 0xE1,		// jmp  ecx
		0xCC,0xCC,0xCC,0xCC,0xCC,//int3...
	};

//	HMODULE kernel32 = GetModuleHandle(L"Kernel32.dll");
//	LPVOID  loadlibrary = GetProcAddress(kernel32, "LoadLibraryW");
	LPVOID  loadlibrary = LoadLibraryW;	//ł悤ȋC
	DWORD   n;

	//opcode2̌Ƀf[^u
	memcpy(opcode2+32, &loadlibrary, sizeof(LPVOID));
	memcpy(opcode2+36, &entrypoint,  sizeof(LPVOID));
	if(!ReadProcessMemory(process, entrypoint, opcode2+40, sizeof(opcode1), &n))//opcode1(8byte)ۑ
		return false;
	wcscpy((LPWSTR)(opcode2+48), dllpath);//LoadLibraryWɓnpX

	//opcode2, mۂē]
	LPVOID mem = VirtualAllocEx(process, NULL, sizeof(opcode2), MEM_COMMIT, PAGE_EXECUTE_READWRITE);
	if(!mem)
		return false;
	if(!WriteProcessMemory(process, mem, opcode2, sizeof(opcode2), &n))
		return false;

	//opcode1, EntryPoint
	memcpy(opcode1+1, &mem, sizeof(LPVOID));
	if(!VirtualProtectEx(process, entrypoint, sizeof(opcode1), PAGE_EXECUTE_READWRITE, &n))
		return false;
	if(!WriteProcessMemory(process, entrypoint, opcode1, sizeof(opcode1), &n))
		return false;
	return true;
}

void SetManagerHook(FARPROC pfnFrom, FARPROC pfnTo);
FARPROC WINAPI Hook_GetProcAddress(HINSTANCE hModule, LPCSTR lpProcName);

#include <pshpack1.h>
struct _hook_thunk {
	BYTE	p1;
	DWORD	p2;
	WORD	p3;
	DWORD	p4;
};
#include <poppack.h>

void InstallManagerHook()
{
	SetManagerHook((FARPROC)GetProcAddress, (FARPROC)Hook_GetProcAddress);
}

void RemoveManagerHook()
{
	SetManagerHook((FARPROC)Hook_GetProcAddress, (FARPROC)GetProcAddress);
}

void SetManagerHook(FARPROC pfnFrom, FARPROC pfnTo)
{
#ifndef _WIN64
	HINSTANCE hinstManager = GetModuleHandle(_T("gdippManager.exe"));
	if (!hinstManager || !g_pSettings->UseManager()) {
		return;
	}

//__asm int 03h;
TRACE(_T("SetManagerHook(0x%p, 0x%p)\n"), pfnFrom, pfnTo);
	LPBYTE pBase = (LPBYTE)hinstManager;
	PIMAGE_DOS_HEADER pdosh = (PIMAGE_DOS_HEADER)pBase;
	if (pdosh->e_magic != IMAGE_DOS_SIGNATURE) {
		return;
	}

	PIMAGE_NT_HEADERS pnth = (PIMAGE_NT_HEADERS)(pBase + pdosh->e_lfanew);
	if (pnth->Signature != IMAGE_NT_SIGNATURE) {
		return;
	}

	const DWORD offs = pnth->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
	const DWORD size = pnth->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].Size;
	if (offs == 0 || size == 0) {
		return;
	}

	HINSTANCE hinstKernel = GetModuleHandleA("kernel32.dll");
	HANDLE hProcess = GetCurrentProcess();
	PIMAGE_IMPORT_DESCRIPTOR pdesc = (PIMAGE_IMPORT_DESCRIPTOR)(pBase + offs);
	for (; pdesc->OriginalFirstThunk != 0; pdesc++) {
		LPCSTR name = (LPCSTR)(pBase + pdesc->Name);
		if (_stricmp(name, "kernel32.dll") != 0) {
			continue;
		}

		DWORD* pIAT = (DWORD*)(pBase + pdesc->FirstThunk);
		for (; *pIAT; pIAT++) {
			const DWORD dwIAT = *pIAT;
			if (dwIAT == (DWORD)pfnFrom) {
				_hook_thunk* p = (_hook_thunk*)VirtualAllocEx(hProcess, NULL, sizeof(_hook_thunk), MEM_COMMIT, PAGE_EXECUTE_READWRITE);
				p->p1 = 0xB8;
				p->p2 = (DWORD)pfnTo;
				p->p3 = 0xE0FF;
				p->p4 = 0xDeadBeef;

TRACE(_T(" Hook: 0x%p -> 0x%p, @0x%p\n"), pfnFrom, pfnTo, pIAT);
				DWORD org = 0;
				VirtualProtect(pIAT, sizeof(DWORD), PAGE_READWRITE, &org);
				InterlockedExchange((LPLONG)pIAT, (LONG)p);
				VirtualProtect(pIAT, sizeof(DWORD), org, &org);
				FlushInstructionCache(hProcess, p, sizeof(_hook_thunk));
				FlushInstructionCache(hProcess, pIAT, sizeof(DWORD));
			} else if (dwIAT < (DWORD)hinstKernel) {
				_hook_thunk thunk;
				if (!ReadProcessMemory(hProcess, (LPVOID)dwIAT, &thunk, sizeof(_hook_thunk), NULL)
					|| thunk.p4 != 0xDeadBeef
					|| thunk.p2 != (DWORD)pfnFrom) {
						continue;
				}
				_hook_thunk* p = (_hook_thunk*)dwIAT;
				InterlockedExchange((LPLONG)&p->p2, (LONG)pfnTo);
				FlushInstructionCache(hProcess, p, sizeof(_hook_thunk));
			}
		}
	}
#endif
}

FARPROC WINAPI Hook_GetProcAddress(HINSTANCE hModule, LPCSTR lpProcName)
{
	if (hModule != GetDLLInstance() || IS_INTRESOURCE(lpProcName)) {
		return GetProcAddress(hModule, lpProcName);
	}

	DWORD d = 0;
	LPCSTR p = lpProcName;
	while (*p) {
		d <<= (*p & 7);
		d ^= (*p++ - 'A');
	}
	if (d == 2593281362U) {
		return (FARPROC)_GetMsgProc;
	}
	return GetProcAddress(hModule, lpProcName);
}
