/* 2006-10-23(by 555)
 * http://hp.vector.co.jp/authors/VA028002/winfreetype.c (higambana(FI))
 * ێʂ
 */
/* 2006-10-27(by 555)
 * http://hp.vector.co.jp/authors/VA028002/freetype.html (higambana(FI))
 * QlɂĂ蒼
 */
/* 2006-10-29(by 555)
 * 693(ƌĂԂƂɂ)͓̐IȊɂďoオEnEn\[X
 * LTCg̕ύX_ɂ݂݂CB(x[Xgdi0164)
 */
/* (by 555)
 * ɐEnEnɂĂgdi0168
 * C^bNƃ{[hǉB
 */
#include "override.h"
#include "ft.h"
#include <windows.h>
//#include <windowsx.h>
#include <tchar.h>

#include <math.h>

#include <ft2build.h>
#include <freetype/freetype.h>	/* FT_FREETYPE_H */
#include <freetype/ftcache.h>	/* FT_CACHE_H */
//#include <freetype/tttags.h>	// FT_TRUETYPE_TAGS_H
//#include <freetype/tttables.h>	// FT_TRUETYPE_TABLES_H
#include <freetype/ftoutln.h>	// FT_OUTLINE_H

#ifdef FT_LCD_FILTER_H
#include <freetype/ftlcdfil.h>	// FT_LCD_FILTER_H
#endif

#include "fteng.h"

#define IsFontBold(lf)		((lf).lfWeight > FW_NORMAL)
#define FT_FixedToInt(x)	(FT_RoundFix(x) >> 16)
#define FT_PosToInt(x)		(((x) + (1 << 5)) >> 6)
#define RESOLUTION_X 72
#define RESOLUTION_Y 72

struct FreeTypeDrawInfo
{
	//FreeTypePrepareݒ肷
	FT_Face freetype_face;
	FTC_FaceID face_id;
	FT_Int cmap_index;
	FT_Bool useKerning;
	FT_Render_Mode render_mode;
	FTC_ImageTypeRec font_type;
	FreeTypeFontInfo* pfi;
	const CFontSettings* pfs;
	FreeTypeFontCache* pftCache;
	UINT _fuOptions;

	//ĂяoOɎŐݒ肷
	HDC hdc;
	int x;
	int yBase;
	int yTop;
	const int* lpDx;
	FREETYPE_PARAMS params;
	CBitmapCache* pCache;

	const LOGFONTW& LogFont() const { return *params.lplf; }
	COLORREF Color() const { return params.color; }
	UINT GetETO() const { return (_fuOptions & 0xffff); }
	bool IsGlyphIndex() const { return !!(_fuOptions & ETO_GLYPH_INDEX); }
	bool IsMono() const { return !!(_fuOptions & FTO_MONO); }
	bool IsSizeOnly() const { return !!(_fuOptions & FTO_SIZE_ONLY); }

#ifdef _DEBUG
	void Validate();
#endif
};

#ifdef _DEBUG
void FreeTypeDrawInfo::Validate()
{
	Assert(params.lplf);
	Assert(_fuOptions == 0);
}
#endif

//overrides.cppŒ`
extern HFONT GetCurrentFont(HDC hdc);
extern void AddFontToFT(HFONT hf, LPCTSTR lpszFace, int weight, bool italic);

//fteng.cppŒ`
extern FT_Library     freetype_library;
extern FTC_Manager    cache_man;
extern FTC_CMapCache  cmap_cache;
extern FTC_ImageCache image_cache;

//FreeType 2.2.1/2.2.2؂ւp
void (*FreeTypeDrawBitmapPixelModeLCD)(
		CBitmapCache& cache,
		const FT_Bitmap *bitmap,
		const int x, const int y,
		const FreeTypeDrawInfo& ftdi);

FORCEINLINE BYTE DoAlphaBlend(BYTE fg, BYTE bg, int alpha)
{
	alpha = Bound(alpha, 0, 255);
	switch (alpha) {
	case 0:
		return bg;
	case 255:
		return fg;
	default:
		{
			WORD temp = ((WORD)(bg)*(WORD)(255 - alpha) +
					(WORD)(fg)*(WORD)((WORD)(alpha)) + (WORD)128);
			return (BYTE)((temp + (temp >> 8)) >> 8);
		}
	}
}

// LCD(t)p̃At@uh(TusNZ_O)
static FORCEINLINE
COLORREF AlphaBlendColorLCD(
		COLORREF baseColor,
		COLORREF newColor,
		int alphaR, int alphaG, int alphaB,
		const int* tableR, const int* tableG, const int* tableB,
		const FreeTypeDrawInfo& ftdi)
{
	const BYTE rs = GetRValue(baseColor);
	const BYTE gs = GetGValue(baseColor);
	const BYTE bs = GetBValue(baseColor);
	BYTE rd = GetRValue(newColor);
	BYTE gd = GetGValue(newColor);
	BYTE bd = GetBValue(newColor);
	// At@l␳
	alphaR = tableR[alphaR] / ftdi.params.alpha;
	alphaG = tableG[alphaG] / ftdi.params.alpha;
	alphaB = tableB[alphaB] / ftdi.params.alpha;
//	rd = (((rd - rs) * alphaR) / 255) + rs;
//	gd = (((gd - gs) * alphaG) / 255) + gs;
//	bd = (((bd - bs) * alphaB) / 255) + bs;
	rd = DoAlphaBlend(rd, rs, alphaR);
	gd = DoAlphaBlend(gd, gs, alphaG);
	bd = DoAlphaBlend(bd, bs, alphaB);
	return RGB(rd, gd, bd);
}

// At@uh(256K)
static FORCEINLINE
COLORREF AlphaBlendColor(
		COLORREF baseColor,
		COLORREF newColor,
		int alpha, const int* table,
		const FreeTypeDrawInfo& ftdi)
{
	const BYTE rs = GetRValue(baseColor);
	const BYTE gs = GetGValue(baseColor);
	const BYTE bs = GetBValue(baseColor);
	BYTE rd = GetRValue(newColor);
	BYTE gd = GetGValue(newColor);
	BYTE bd = GetBValue(newColor);
	// At@l␳
	alpha = table[alpha] / ftdi.params.alpha;
//	rd = (rs * (255 - alpha) + rd * alpha) / 255;
//	gd = (gs * (255 - alpha) + gd * alpha) / 255;
//	bd = (bs * (255 - alpha) + bd * alpha) / 255;

//	rd = (((rd - rs) * alpha) / 255) + rs;
//	gd = (((gd - gs) * alpha) / 255) + gs;
//	bd = (((bd - bs) * alpha) / 255) + bs;
	rd = DoAlphaBlend(rd, rs, alpha);
	gd = DoAlphaBlend(gd, gs, alpha);
	bd = DoAlphaBlend(bd, bs, alpha);
	return RGB(rd, gd, bd);
}

// 2K
static void FreeTypeDrawBitmapPixelModeMono(
		CBitmapCache& cache,
		const FT_Bitmap *bitmap,
		const int x, const int y,
		const FreeTypeDrawInfo& ftdi)
{
	int i, j;
	int dx, dy;	// display
	FT_Bytes p;

	if(bitmap->pixel_mode != FT_PIXEL_MODE_MONO){
		return;
	}

	const COLORREF color = ftdi.Color();

	const int width = bitmap->width;
	const int height = bitmap->rows;

	for(j = 0, dy = y; j < height; ++j, ++dy){
		p = bitmap->pitch < 0 ?
			&bitmap->buffer[(-bitmap->pitch * bitmap->rows) - bitmap->pitch * j] :	// up-flow
			&bitmap->buffer[bitmap->pitch * j];	// down-flow
		for(i = 0, dx = x; i < width; ++i, ++dx){
			if((p[i / 8] & (1 << (7 - (i % 8)))) != 0){
				cache.SetPixelV(dx, dy, color);
			}
		}
	}
}

// LCD(t)p`(TusNZ_O)
// RGB(̂͂)
static void FreeTypeDrawBitmapPixelModeLCD_222(
		CBitmapCache& cache,
		const FT_Bitmap *bitmap,
		const int x, const int y,
		const FreeTypeDrawInfo& ftdi)
{
	int i, j;
	int dx, dy;	// display
	COLORREF c;
	FT_Bytes p;

	if(bitmap->pixel_mode != FT_PIXEL_MODE_LCD){
		return;
	}

	const COLORREF color = ftdi.Color();
	const int AAMode  = ftdi.pfs->GetAntiAliasMode();
	const int* tableR = g_pSettings->GetTuneTableR();
	const int* tableG = g_pSettings->GetTuneTableG();
	const int* tableB = g_pSettings->GetTuneTableB();

	// LCD3TusNZ
	const int width = bitmap->width;
	const int height = bitmap->rows;
	const int width_3 = width - 3;

	for(j = 0, dy = y; j < height; ++j, ++dy){
		p = bitmap->pitch < 0 ?
			&bitmap->buffer[(-bitmap->pitch * bitmap->rows) - bitmap->pitch * j] :	// up-flow
			&bitmap->buffer[bitmap->pitch * j];	// down-flow

		int alphaR, alphaG, alphaB;
		for(i = 0, dx = x; i < width; i += 3, ++dx){
			const COLORREF backColor = cache.GetPixel(dx, dy);

			if(AAMode == 2){
				// RGB̏ɃTusNZfBXvCp
				alphaR = p[i + 0];
				alphaG = p[i + 1];
				alphaB = p[i + 2];
			}else{
				// BGR
				alphaR = p[i + 2];
				alphaG = p[i + 1];
				alphaB = p[i + 0];
			}
			c = AlphaBlendColorLCD(
				backColor, color,
				alphaR, alphaG, alphaB,
				tableR, tableG, tableB,
				ftdi
			);
			cache.SetPixelV(dx, dy, c);
		}

		if (i >= width)
			continue;
	}
}

static void FreeTypeDrawBitmapPixelModeLCD_221(
		CBitmapCache& cache,
		const FT_Bitmap *bitmap,
		const int x, const int y,
		const FreeTypeDrawInfo& ftdi)
{
	int i, j;
	int dx, dy;	// display
	COLORREF c;
	FT_Bytes p;

	if(bitmap->pixel_mode != FT_PIXEL_MODE_LCD){
		return;
	}

	const COLORREF color = ftdi.Color();
	const int AAMode  = ftdi.pfs->GetAntiAliasMode();
	const int* tableR = g_pSettings->GetTuneTableR();
	const int* tableG = g_pSettings->GetTuneTableG();
	const int* tableB = g_pSettings->GetTuneTableB();

	// LCD3TusNZ
	const int width = bitmap->width;
	const int height = bitmap->rows;
	const int width_3 = width - 3;

	for(j = 0, dy = y; j < height; ++j, ++dy){
		p = bitmap->pitch < 0 ?
			&bitmap->buffer[(-bitmap->pitch * bitmap->rows) - bitmap->pitch * j] :	// up-flow
			&bitmap->buffer[bitmap->pitch * j];	// down-flow

		int alphaR, alphaG, alphaB;
		i = 0;
		dx = x;
		COLORREF backColor = cache.GetPixel(dx, dy);

		//Ql: {gdi++.dll̃\[X
		if(AAMode == 2){
			//RGB
			alphaR = (p[i + 0] + p[i + 1]) / 2;
			alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
			alphaB = (p[i + 1] + p[i + 2] + p[i + 3]) / 3;
		}else{
			// BGR
			alphaR = (p[i + 1] + p[i + 2] + p[i + 3]) / 3;
			alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
			alphaB = (p[i + 0] + p[i + 1]) / 2;
		}
		c = AlphaBlendColorLCD(
			backColor, color,
			alphaR, alphaG, alphaB,
			tableR, tableG, tableB,
			ftdi
		);
		cache.SetPixelV(dx, dy, c);

		for(i = 3, dx = x + 1; i < width_3; i += 3, ++dx){
			backColor = cache.GetPixel(dx, dy);

			if(AAMode == 2){
				// RGB̏ɃTusNZfBXvCp
				alphaR = (p[i +-1] + p[i + 0] + p[i + 1]) / 3;
				alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
				alphaB = (p[i + 1] + p[i + 2] + p[i + 3]) / 3;
			}else{
				// BGR
				alphaR = (p[i + 1] + p[i + 2] + p[i + 3]) / 3;
				alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
				alphaB = (p[i +-1] + p[i + 0] + p[i + 1]) / 3;
			}
			c = AlphaBlendColorLCD(
				backColor, color,
				alphaR, alphaG, alphaB,
				tableR, tableG, tableB,
				ftdi
			);
			cache.SetPixelV(dx, dy, c);
		}

		if (i >= width)
			continue;
		backColor = cache.GetPixel(dx, dy);

		if(AAMode == 2){
			// RGB̏ɃTusNZfBXvCp
			alphaR = (p[i +-1] + p[i + 0] + p[i + 1]) / 3;
			alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
			alphaB = (p[i + 1] + p[i + 2]) / 2;
		}else{
			// BGR
			alphaR = (p[i + 1] + p[i + 2]) / 2;
			alphaG = (p[i + 0] + p[i + 1] + p[i + 2]) / 3;
			alphaB = (p[i +-1] + p[i + 0] + p[i + 1]) / 3;
		}
		c = AlphaBlendColorLCD(
			backColor, color,
			alphaR, alphaG, alphaB,
			tableR, tableG, tableB,
			ftdi
		);
		cache.SetPixelV(dx, dy, c);
	}
}

// Otrbg}bṽ_O
static void FreeTypeDrawBitmap(
		CBitmapCache& cache,
		const FT_Bitmap *bitmap,
		const int x, const int y,
		const FreeTypeDrawInfo& ftdi)
{
	int i, j;
	int dx, dy;	// display
	int width, height;
	COLORREF c;
	FT_Bytes p;

	if(bitmap->pixel_mode != FT_PIXEL_MODE_GRAY){
		// ̊֐̂FT_PIXEL_MODE_GRAYɂ̂ݑΉɈϏ
		switch(bitmap->pixel_mode){
		case FT_PIXEL_MODE_MONO:
			FreeTypeDrawBitmapPixelModeMono(
				cache, bitmap, x, y, ftdi);
			break;
		case FT_PIXEL_MODE_LCD:
			FreeTypeDrawBitmapPixelModeLCD(
				cache, bitmap, x, y, ftdi);
			break;
		default:
			return;		// Ή
		}
		return;
	}

	const COLORREF color = ftdi.Color();
	const int* table = g_pSettings->GetTuneTable();
	width = bitmap->width;
	height = bitmap->rows;

	for(j = 0, dy = y; j < height; ++j, ++dy){
		p = bitmap->pitch < 0 ?
			&bitmap->buffer[(-bitmap->pitch * bitmap->rows) - bitmap->pitch * j] :	// up-flow
			&bitmap->buffer[bitmap->pitch * j];	// down-flow
		for(i = 0, dx = x; i < width; ++i, ++dx){
			const COLORREF backColor = cache.GetPixel(dx, dy);
			c = AlphaBlendColor(
				backColor, color,
				p[i], table, ftdi
			);
			cache.SetPixelV(dx, dy, c);
		}
	}
}


BOOL FreeTypePrepare(FreeTypeDrawInfo& FTInfo)
{
//CDebugElapsedCounter cntr("FreeTypePrepare");
#ifdef _DEBUG
	FTInfo.Validate();
#endif

	FT_Face& freetype_face			= FTInfo.freetype_face;
	FTC_FaceID& face_id				= FTInfo.face_id;
	FT_Int& cmap_index				= FTInfo.cmap_index;
	FT_Render_Mode& render_mode		= FTInfo.render_mode;
	FTC_ImageTypeRec& font_type		= FTInfo.font_type;
	FreeTypeFontInfo*& pfi			= FTInfo.pfi;
	const CFontSettings*& pfs		= FTInfo.pfs;
	FreeTypeFontCache*& pftCache	= FTInfo.pftCache;
	FTInfo._fuOptions				= FTInfo.params.fuOptions;

	FT_Size font_size;
	FTC_ScalerRec scaler = { 0 };

	const LOGFONTW& lf = FTInfo.LogFont();
	render_mode		= FT_RENDER_MODE_NORMAL;
	if (FTInfo.params.alpha < 1)
		FTInfo.params.alpha = 1;

	pfi = g_pFTEngine->FindFont(lf.lfFaceName, lf.lfWeight, !!lf.lfItalic);
	if(!pfi)
		return FALSE;

	pfs = &pfi->GetFontSettings();
	face_id = (FTC_FaceID)pfi->GetId();
	if(FTC_Manager_LookupFace(cache_man, face_id, &freetype_face))
		return FALSE;

	cmap_index = FT_Get_Charmap_Index(freetype_face->charmap);
	scaler.face_id	= face_id;
	scaler.width	= lf.lfWidth;
	if(lf.lfHeight > 0){
		// Z
		scaler.height = MulDiv(lf.lfHeight, freetype_face->units_per_EM, freetype_face->height);
	}
	else{
		// 
		scaler.height = -lf.lfHeight;
	}
	scaler.pixel = 1;
	scaler.x_res = 0;
	scaler.y_res = 0;
	if(FTC_Manager_LookupSize(cache_man, &scaler, &font_size))
		return FALSE;

	pftCache = pfi->GetCache(scaler.height, lf);
	if(!pftCache)
		return FALSE;

/*	FT_Size_RequestRec size_request;
	size_request.width = lf.lfWidth;
	size_request.horiResolution = 0;
	size_request.vertResolution = 0;
	if(lf.lfHeight > 0){
		// Z
		size_request.type = FT_SIZE_REQUEST_TYPE_CELL;
		size_request.height = lf.lfHeight * 64;
	}
	else{
		// 
		size_request.type = FT_SIZE_REQUEST_TYPE_NOMINAL;
		size_request.height = (-lf.lfHeight) * 64;
	}
	if(FT_Request_Size(freetype_face, &size_request))
		goto Exit2;*/

	// font_typeݒ
	font_type.face_id = face_id;
	font_type.width   = freetype_face->size->metrics.x_ppem;
	font_type.height  = freetype_face->size->metrics.y_ppem;

	/* rbg}bv܂ŃLbVꍇFT_LOAD_RENDER | FT_LOAD_TARGET_*
	 * ƂBrTARGETύXꍇ̓LbVזB
	 * FT_LOAD_DEFAULTɂFTC_ImageCache_Lookup
	 * FT_Glyph_To_BitmapقsƎvB
	 */
	// Bold͑Ƃ̂̂Ŗ{͂ꂾł͑ȂCB
/*	if(IsFontBold(lf) && !(freetype_face->style_flags & FT_STYLE_FLAG_BOLD) ||
		lf.lfItalic && !(freetype_face->style_flags & FT_STYLE_FLAG_ITALIC)){
		// {[hAC^bN͌Ń_O
		// x͗򉻂邾낤ǎdȂB
		font_type.flags = FT_LOAD_NO_BITMAP;
	}
	else{
		font_type.flags = FT_LOAD_RENDER | FT_LOAD_NO_BITMAP;
	}*/
	font_type.flags = FT_LOAD_NO_BITMAP;

	// qeBO
	switch (pfs->GetHintingMode()) {
	case 0:
		// ignore.
		break;
	case 1:
		font_type.flags |= FT_LOAD_NO_HINTING;
		break;
	case 2:
		font_type.flags |= FT_LOAD_FORCE_AUTOHINT;
		break;
	}
	// A`GCAX
	if (FTInfo.IsMono()) {
		font_type.flags |= FT_LOAD_TARGET_MONO;
		render_mode = FT_RENDER_MODE_MONO;
	} else {
		switch (pfs->GetAntiAliasMode()) {
		case -1:
			font_type.flags |= FT_LOAD_TARGET_MONO;
			render_mode = FT_RENDER_MODE_MONO;
			break;
		case 0:
			font_type.flags |= FT_LOAD_TARGET_NORMAL;
			render_mode = FT_RENDER_MODE_NORMAL;
			break;
		case 1:
			font_type.flags |= FT_LOAD_TARGET_LIGHT;
			render_mode = FT_RENDER_MODE_LIGHT;
			break;
		case 2:
		case 3:
			font_type.flags |= FT_LOAD_TARGET_LCD;
			render_mode = FT_RENDER_MODE_LCD;
			break;
		}
	}

	FTInfo.useKerning = pfs->GetKerning() && FT_HAS_KERNING(freetype_face);
	return TRUE;
}

BOOL ForEachGetGlyph(FreeTypeDrawInfo& FTInfo, LPCTSTR lpString, int cbString, BOOL (CALLBACK *pfnCallback)(FreeTypeDrawInfo&, const WCHAR wch, const FT_BitmapGlyph))
{
	const FT_Face freetype_face = FTInfo.freetype_face;
	const FTC_FaceID face_id = FTInfo.face_id;
	const FT_Int cmap_index = FTInfo.cmap_index;
	const FT_Bool useKerning = FTInfo.useKerning;
	const FT_Render_Mode render_mode = FTInfo.render_mode;
	const LOGFONTW& lf = FTInfo.LogFont();
	FreeTypeFontCache* pftCache = FTInfo.pftCache;
	const bool bGlyphIndex = FTInfo.IsGlyphIndex();
	const bool bSizeOnly = FTInfo.IsSizeOnly();
//	const bool bOwnCache = !(FTInfo.font_type.flags & FT_LOAD_RENDER);

	LPCTSTR lpEnd = lpString + cbString;
	FT_UInt previous = 0;

	while(lpString < lpEnd){
		const WCHAR wch = *lpString;
		FreeTypeCharData* chData = NULL;
//		if (bSizeOnly || bOwnCache) {
			chData = bGlyphIndex
						? pftCache->FindGlyphIndex(wch)
						: pftCache->FindChar(wch);
//		}

		if (bSizeOnly && chData) {
//			TRACE(_T("Cache hit: GetCharWidth [%c]\n"), *lpString);
			FTInfo.x += chData->GetWidth() + FTInfo.params.charExtra;
			++lpString;	// Next Character
			continue;
		}

		FT_Glyph glyph = NULL;
		FT_BitmapGlyph glyph_bitmap = NULL;

		FT_Glyph copy_glyph = NULL;

		// BMPO͍̕lĂȂB
		// BMPOɂĂ̓TQ[gyAl邩UTF-32ɂ΂낤
		FT_UInt glyph_index = bGlyphIndex
			? wch
			: FTC_CMapCache_Lookup(
				cmap_cache,
				face_id,
				cmap_index,
				*lpString);

		if(glyph_index == 0 && wch) {
#ifdef _DEBUG
			GdiSetBatchLimit(0);
#endif
			int x;
			if (!ORIG_GetCharWidth32W(FTInfo.hdc, wch, wch, &x))
				return FALSE;
			if (!bSizeOnly && FTInfo.params.alpha == 1)
				ORIG_ExtTextOutW(FTInfo.hdc, FTInfo.x, FTInfo.yTop, FTInfo.GetETO(), NULL, &wch, 1, NULL);
			//TRACE(_T("ForEachGetGlyph: glyph=0, %.4x, %d\n"), wch, x);
			FTInfo.x += x;
			++lpString;	// Next Character
			continue;
		}

		// J[jO
		if(useKerning){
			if(previous != 0 && glyph_index){
				FT_Vector delta;
				FT_Get_Kerning(freetype_face,
					previous, glyph_index,
					ft_kerning_default, &delta);
				FTInfo.x += FT_PosToInt(delta.x);
			}
			previous = glyph_index;
		}

		if(chData && chData->GetGlyph(render_mode)) {
			glyph_bitmap = (FT_BitmapGlyph)chData->GetGlyph(render_mode);
//			TRACE(_T("Cache Hit: %wc, size:%d, 0x%8.8X\n"), wch, chData->GetWidth(), glyph_bitmap);
		}
		else {
			if(FTC_ImageCache_Lookup(
				image_cache,
				&FTInfo.font_type,
				glyph_index,
				&glyph,
				NULL))
			{
				return FALSE;
			}
			/* font_type.flagsFT_LOAD_RENDERIȂ
			 * OtC[W擾Ă̂Ńrbg}bvɕϊB
			 */
			if(glyph->format == FT_GLYPH_FORMAT_BITMAP){
				glyph_bitmap = (FT_BitmapGlyph)glyph;
			}
			else{
//				FT_Glyph copy_glyph = NULL;
				if(FT_Glyph_Copy(glyph, &copy_glyph))
					return FALSE;

				// AEgCό`(LTCg)B
				if(IsFontBold(lf)) {
					if(!(freetype_face->style_flags & FT_STYLE_FLAG_BOLD)){
						// 
						//int strength = FTInfo.pfi->CalcBoldWeight(lf);	// 
						const int strength = FTInfo.pfi->GetFTWeight();
						if(strength && FT_Outline_Embolden(
							&((FT_OutlineGlyph)copy_glyph)->outline,
							strength))
						{
							FT_Done_Glyph(copy_glyph);
							return FALSE;		// ϊs
						}
/*						if (copy_glyph->advance.x) {
							FT_Matrix matrix;
							matrix.xx = (1 << 16) + (0x80000000 / (copy_glyph->advance.x >> 1));
							matrix.xy = 0;
							matrix.yx = 0;
							matrix.yy = 1 << 16;
							FT_Outline_Transform(
								&((FT_OutlineGlyph)copy_glyph)->outline,
								&matrix);
						}*/
						((FT_BitmapGlyph)copy_glyph)->root.advance.x += 0x10000;
					}
				} else {
					const int strength = FTInfo.pfi->CalcNormalWeight();
					if(strength && FT_Outline_Embolden(
						&((FT_OutlineGlyph)copy_glyph)->outline,
						strength))
					{
						FT_Done_Glyph(copy_glyph);
						return FALSE;		// ϊs
					}
				}
				if(lf.lfItalic && !(freetype_face->style_flags & FT_STYLE_FLAG_ITALIC)){
					// Α
					FT_Matrix matrix;
					// ϊ
					FTInfo.pfi->CalcItalicSlant(matrix);
					FT_Outline_Transform(
						&((FT_OutlineGlyph)copy_glyph)->outline,
						&matrix);
				}

				/* FT_RENDER_MODE_NORMALŕʂ(256K)A`GCAX
				 * FT_RENDER_MODE_LCDŉtpA`GCAX(TusNZ_O)
				 */
				if(FT_Glyph_To_Bitmap(&copy_glyph, render_mode, 0, 1)){
					FT_Done_Glyph(copy_glyph);
					return FALSE;
				}
				glyph_bitmap = (FT_BitmapGlyph)copy_glyph;
			}
		}

		const int cx = FT_FixedToInt(glyph_bitmap->root.advance.x);
		if (pfnCallback(FTInfo, wch, glyph_bitmap)) {
			FTInfo.x += FT_FixedToInt(glyph_bitmap->root.advance.x);
		}

//		if (bSizeOnly || bOwnCache) {
			//LbV
			if (bGlyphIndex)
				pftCache->AddGlyphData(glyph_index, cx, glyph_bitmap, render_mode);
			else
				pftCache->AddCharData(wch, glyph_index, cx, glyph_bitmap, render_mode);
//		}
		FTInfo.x += FTInfo.params.charExtra;

		if(copy_glyph){
			FT_Done_Glyph(copy_glyph);
		}
		++lpString;	// Next Character
	}
	return TRUE;
}

BOOL GetLogFontFromDC(HDC hdc, LOGFONT& lf)
{
	LOGFONTW lfForce = { 0 };
	HFONT hf = GetCurrentFont(hdc);
	if (!GetObject(hf, sizeof(LOGFONTW), &lf))
		return FALSE;
	if (g_pSettings->CopyForceFont(lfForce, lf))
		lf = lfForce;

	if(g_pSettings->LoadOnDemand()) {
		AddFontToFT(hf, lf.lfFaceName, lf.lfWeight, !!lf.lfItalic);
	}
	return TRUE;
}

BOOL CALLBACK TextOutCallback(FreeTypeDrawInfo& FTInfo, const WCHAR wch, const FT_BitmapGlyph glyph_bitmap)
{
	if (!glyph_bitmap->bitmap.buffer) {
		if (FTInfo.params.alpha == 1)
			ORIG_ExtTextOutW(FTInfo.hdc, FTInfo.x, FTInfo.yTop, FTInfo.GetETO(), NULL, &wch, 1, NULL);
	} else {
		FreeTypeDrawBitmap(*FTInfo.pCache,
			&glyph_bitmap->bitmap,
			FTInfo.x + glyph_bitmap->left,
			FTInfo.yBase - glyph_bitmap->top,
			FTInfo);
	}

	if (FTInfo.lpDx) {
		FTInfo.x += *FTInfo.lpDx++;
		return FALSE;
	}
	return TRUE;
}

BOOL CALLBACK GetTextExtentCallback(FreeTypeDrawInfo& FTInfo, const WCHAR wch, const FT_BitmapGlyph glyph_bitmap)
{
	return TRUE;
}

// FreeTypepTextOut APIǂ
BOOL FreeTypeTextOut(
	const HDC hdc,     // foCXReLXg̃nh
	CBitmapCache& cache,
	const int nXStart, // Jnʒui_j x W
	const int nYStart, // Jnʒui_j y W
	LPCWSTR lpString,  // 
	int cbString,      // 
	const int* lpDx,   // `ʒu
	const FREETYPE_PARAMS* params
	)
{
	CCriticalSectionLock __lock;

	// Unicodeœn悤ɂ(FT_Select_CharmapŕύX\)
	if(cbString <= 0 || lpString == NULL)
		return FALSE;

	FreeTypeDrawInfo FTInfo = { 0 };
	FTInfo.pCache		= &cache;
	FTInfo.hdc			= hdc;
	FTInfo.lpDx			= lpDx;
	FTInfo.params		= *params;

	LOGFONTW lfForce = { 0 };
	if (g_pSettings->CopyForceFont(lfForce, *params->lplf))
		FTInfo.params.lplf	= &lfForce;
	if(!FreeTypePrepare(FTInfo))
		return FALSE;

	FT_Face freetype_face = FTInfo.freetype_face;
	const LOGFONT& lf = FTInfo.LogFont();

	/* x[XC̈ʒu
	 * size->metrics.height6rbǧŒ菬ł̃tHg̍
	 * ascender̓x[XC̒
	 * units_per_EMascenderdescenderAheight̒P
	 */
//	TRACE(_T("%ls, asc:%d, des:%d, height: %d, met: %d, scl: %d, uPe: %d\n"),
//			lf.lfFaceName,
//			freetype_face->ascender, freetype_face->descender, freetype_face->height,
//			freetype_face->size->metrics.y_ppem, freetype_face->size->metrics.y_scale, freetype_face->units_per_EM);

	FTInfo.x     = nXStart;
	FTInfo.yTop  = nYStart;

	const TEXTMETRIC& tm = FTInfo.pftCache->GetTextMetric(hdc);
	FTInfo.yBase = nYStart + tm.tmAscent;
	if(!ForEachGetGlyph(FTInfo, lpString, cbString, TextOutCallback))
		return FALSE;

	const int x = FTInfo.x;
	const int y = FTInfo.yBase;

	// ()
	if(lf.lfUnderline){
		//̈ʒu
		int yPos = y + 1;
		const int height = FT_PosToInt(freetype_face->size->metrics.height);
		if (yPos >= height) {
			yPos = height - 1;
		}
		// Kȑ
		const int thickness =
			MulDiv(freetype_face->underline_thickness,
					freetype_face->size->metrics.y_ppem,
					freetype_face->units_per_EM);
		cache.DrawHorizontalLine(nXStart, yPos, x, FTInfo.Color(), thickness);
	}

	// ()
	if(lf.lfStrikeOut){
		// ̈ʒu(FreeTypeŎ擾łɂȂ̂Win32APIp)
		OUTLINETEXTMETRIC otm = { sizeof(OUTLINETEXTMETRIC) };
		GetOutlineTextMetrics(hdc, otm.otmSize, &otm);
		const int yPos = y - otm.otmsStrikeoutPosition;
		// Kȑ
		const int thickness =
			MulDiv(freetype_face->underline_thickness,
					freetype_face->size->metrics.y_ppem,
					freetype_face->units_per_EM);
		cache.DrawHorizontalLine(nXStart, yPos, x, FTInfo.Color(), thickness);
	}

//PatBlt(hdc, 0, y, 9999, y + 1, DSTINVERT);
//PatBlt(hdc, 0, 0, 9999, 0 + 1, DSTINVERT);
	return TRUE;
}

BOOL FreeTypeGetTextExtentPoint(
	const HDC hdc,
	LPCWSTR lpString,
	int cbString,
	LPSIZE lpSize,
	const FREETYPE_PARAMS* params
	)
{
	CCriticalSectionLock __lock;

	//Ƃ肠0
	if (lpSize) {
		lpSize->cx = lpSize->cy = 0;
	}

	// Unicodeœn悤ɂ(FT_Select_CharmapŕύX\)
	if(cbString <= 0 || lpString == NULL || lpSize == NULL) {
		return FALSE;
	}

	Assert(params != NULL);
	LOGFONT lf;
	if (!GetLogFontFromDC(hdc, lf))
		return FALSE;

	FreeTypeDrawInfo FTInfo = { 0 };
	FTInfo.params			= *params;
	FTInfo.params.lplf		= &lf;
	FTInfo.params.fuOptions	|= FTO_SIZE_ONLY;
	FTInfo.hdc				= hdc;
	if(!FreeTypePrepare(FTInfo))
		return FALSE;

	FT_Face freetype_face = FTInfo.freetype_face;

	FTInfo.x = 0;
	if(!ForEachGetGlyph(FTInfo, lpString, cbString, GetTextExtentCallback)) {
		lpSize->cx = 0;
		lpSize->cy = 0;
		return FALSE;
	}

	lpSize->cx = FTInfo.x;
	lpSize->cy = FTInfo.pftCache->GetTextMetric(hdc).tmHeight;
	return TRUE;

	//܂ĂȂ̎c[
//	return ORIG_GetTextExtentPoint32W(hdc, lpString, cbString, lpSize);
}

BOOL FreeTypeGetCharWidth(const HDC hdc, UINT iFirstChar, UINT iLastChar, LPINT lpBuffer)
{
	CCriticalSectionLock __lock;

	if (!lpBuffer || iFirstChar > iLastChar || iFirstChar > 0xffff || iLastChar > 0xffff) {
		SetLastError(ERROR_INVALID_PARAMETER);
		return FALSE;
	}

	//Ƃ肠0
	ZeroMemory(lpBuffer, sizeof(INT) * (iLastChar - iFirstChar));

	LOGFONT lf;
	if (!GetLogFontFromDC(hdc, lf))
		return FALSE;

	FreeTypeDrawInfo FTInfo	= { 0 };
	FTInfo.params.lplf		= &lf;
	FTInfo.params.fuOptions	= FTO_SIZE_ONLY;
	FTInfo.hdc				= hdc;
	if(!FreeTypePrepare(FTInfo))
		return FALSE;

	FT_Face freetype_face = FTInfo.freetype_face;

	WCHAR wch = (WORD)iFirstChar;
	const WCHAR wend = (WORD)iLastChar;

	while (wch <= wend) {
		FTInfo.x = 0;
		if(!ForEachGetGlyph(FTInfo, &wch, 1, GetTextExtentCallback))
			return FALSE;
		*lpBuffer++ = FTInfo.x;
		wch++;
	}
	return TRUE;
}

FT_Error face_requester(
		FTC_FaceID face_id,
		FT_Library library,
		FT_Pointer request_data,
		FT_Face* aface)
{
	FT_Error ret;
	FT_Face face;

	FreeTypeFontInfo* pfi = g_pFTEngine->FindFont((int)face_id);
	Assert(pfi);
	if (!pfi) {
		return FT_Err_Invalid_Argument;
	}
	LPCTSTR fontname = pfi->GetName();

	// ̂w肵ătHg擾
	FreeTypeSysFontData* pData = FreeTypeSysFontData::CreateInstance(fontname, pfi->GetFontWeight(), pfi->IsItalic());
	if(pData == NULL){
		return FT_Err_Cannot_Open_Resource;
	}

	face = pData->GetFace();
	Assert(face != NULL);

	// Charmapݒ肵Ă
	ret = FT_Select_Charmap(face, FT_ENCODING_UNICODE);
	if(ret != FT_Err_Ok){
		FT_Done_Face(face);
		return ret;
	}

	*aface = face;
	return 0;
}


/*
DWORD FreeTypeGetVersion()
{
	int major = 0, minor = 0, patch = 0;
	FT_Library_Version(freetype_library, &major, &minor, &patch);
	//ʓ|Ȃ̂RGB}Ngp
	return RGB(major, minor, patch);
}*/

//_~[
FT_EXPORT( FT_Error )
FT_Library_SetLcdFilter_Dummy( FT_Library    library,
                               FT_LcdFilter  filter )
{
	return 0;
}

BOOL FontLInit(void){
	CCriticalSectionLock __lock;

	if(FT_Init_FreeType(&freetype_library)){
		return FALSE;
	}
	if(FTC_Manager_New(freetype_library,
		g_pSettings->CacheMaxFaces(),
		g_pSettings->CacheMaxSizes(),
		g_pSettings->CacheMaxBytes(),
		face_requester, NULL,
		&cache_man))
	{
		FontLFree();
		return FALSE;
	}
	if(FTC_CMapCache_New(cache_man, &cmap_cache)){
		FontLFree();
		return FALSE;
	}
	if(FTC_ImageCache_New(cache_man, &image_cache)){
		FontLFree();
		return FALSE;
	}

	// FreeType2.2.2ǂ
/*	const DWORD ver = FreeTypeGetVersion();
	const BYTE major = GetRValue(ver);
	const BYTE minor = GetGValue(ver);
	const BYTE patch = GetBValue(ver);
//	m_bHaveNewerFreeType = (major > 2 || (major >= 2 && (minor > 2 || (minor >= 2 && patch >= 2))));
	if (major > 2)
		m_bHaveNewerFreeType = true;
	else if (major >= 2 && minor > 2)
		m_bHaveNewerFreeType = true;
	else if (major >= 2 && minor >= 2 && patch >= 2)
		m_bHaveNewerFreeType = true;
	else
		m_bHaveNewerFreeType = false;*/

	// FreeType2.2.2Ȃ
#ifdef _DEBUG
	#define c_szFreeTypeDLL		_T("FreeTypeD.dll")
#else
	#define c_szFreeTypeDLL		_T("FreeType.dll")
#endif
	union {
		FARPROC pfn;
		FT_Error (*_FT_Library_SetLcdFilter)(FT_Library, FT_LcdFilter);
	};
	pfn = GetProcAddress(GetModuleHandle(c_szFreeTypeDLL), "FT_Library_SetLcdFilter");
	if (pfn) {
		const int nLcdFilter = g_pSettings->LcdFilter();
		if ((int)FT_LCD_FILTER_NONE < nLcdFilter && nLcdFilter < (int)FT_LCD_FILTER_MAX) {
			_FT_Library_SetLcdFilter(freetype_library, (FT_LcdFilter)nLcdFilter);
		}
		FreeTypeDrawBitmapPixelModeLCD = FreeTypeDrawBitmapPixelModeLCD_222;
	} else {
		FreeTypeDrawBitmapPixelModeLCD = FreeTypeDrawBitmapPixelModeLCD_221;
	}
	return TRUE;
}

void FontLFree(void){
	CCriticalSectionLock __lock;

	if(cache_man != NULL)
		FTC_Manager_Done(cache_man);
	if(freetype_library != NULL)
		FT_Done_FreeType(freetype_library);
	cache_man = NULL;
	freetype_library = NULL;
}

/*
//HHH
#pragma comment(linker, "/export:_FreeTypeAdjustLCD@4,@100,NONAME")
extern "C"
BOOL WINAPI FreeTypeAdjustLCD(const FT_Byte* filter_weights)
{
	CCriticalSectionLock __lock;

	if(cache_man != NULL)
		FTC_Manager_Done(cache_man);
	if(FTC_Manager_New(freetype_library,
				g_pSettings->CacheMaxFaces(),
				g_pSettings->CacheMaxSizes(),
				g_pSettings->CacheMaxBytes(),
				face_requester, NULL,
				&cache_man) ||
			FTC_CMapCache_New(cache_man, &cmap_cache) ||
			FTC_ImageCache_New(cache_man, &image_cache)) {
		FontLFree();
		FatalAppExit(0, _T("FreeType initialization failure"));
		return FALSE;
	}

#ifdef _DEBUG
	#define c_szFreeTypeDLL		_T("FreeTypeD.dll")
#else
	#define c_szFreeTypeDLL		_T("FreeType.dll")
#endif

	union {
		FARPROC pfn;
		FT_Error (*_FT_Library_SetLcdFilter)(FT_Library, const FT_Byte*);
	};
	pfn = GetProcAddress(GetModuleHandle(c_szFreeTypeDLL), "FT_Library_SetLcdFilter");
	if (pfn)
		return (_FT_Library_SetLcdFilter(freetype_library, filter_weights) == 0);
	return FALSE;
}
*/
