#include "common.h"
CRITICAL_SECTION CCriticalSectionLock::m_cs;

LPWSTR _StrDupExAtoW(LPCSTR pszMB, int cchMB /*= -1*/, LPWSTR pszStack /*= NULL*/, int cchStack /*= 0*/, int* pcchWC /*= NULL*/)
{
	int _cchWC;
	if (!pcchWC) {
		pcchWC = &_cchWC;
	}
	*pcchWC = 0;

	if (!pszMB) {
		return NULL;
	}
	if (cchMB == -1) {
		cchMB = strlen(pszMB);
	}
	const int cchWC = MultiByteToWideChar(CP_ACP, 0, pszMB, cchMB, NULL, 0);
	if(cchWC < 0) {
		return NULL;
	}

	LPWSTR pszWC;
	if(cchWC < cchStack && pszStack) {
		pszWC = pszStack;
	} else {
		pszWC = (LPWSTR)malloc(sizeof(WCHAR) * (cchWC + 1));
		if (!pszWC) {
			return NULL;
		}
	}
	ZeroMemory(pszWC, sizeof(WCHAR) * (cchWC + 1));
	MultiByteToWideChar(CP_ACP, 0, pszMB, cchMB, pszWC, cchWC);
	pszWC[cchWC] = L'\0';
	*pcchWC = cchWC;
	return pszWC;
}

#ifndef PathFindExtension
//MSJCabviewTvq
LPTSTR PathFindExtension(LPCTSTR pszPath)
{
	LPCTSTR pszDot;

	for (pszDot = NULL; *pszPath; pszPath = CharNext(pszPath))
	{
		switch (*pszPath) {
		case TEXT('.'):
			pszDot = pszPath;		// remember the last dot
			break;
		case TEXT('\\'):
		case TEXT(' '):				// extensions can't have spaces
			pszDot = NULL;			// forget last dot, it was in a directory
			break;
		}
	}

	// if we found the extension, return ptr to the dot, else
	// ptr to end of the string (NULL extension) (cast->non const)
	return pszDot ? (LPTSTR)pszDot : (LPTSTR)pszPath;
}
#endif

#ifdef _DEBUG
typedef struct {
	LPCSTR		name;
	UINT		flag;
	UINT		mask;
	UINT		xor;
} FLAG_NAME_MAP;
#define DEF_FLAG_NAME(f,m,x)	{ #f, f, m, x }

LPCSTR Dbg_GetFlagNames(UINT flags, const FLAG_NAME_MAP* p, LPSTR worker)
{
	if (!worker)
		return "";
	if (!flags || !p)
		return "0";

	*worker = '\0';
	while (p->name) {
		if (((flags & p->mask) ^ p->xor) == p->flag) {
			if (*worker) {
				memcpy(worker, " | ", 4);
				worker += 3;
			}
			strcpy(worker, p->name);
			worker += strlen(p->name);
			flags &= ~p->mask;
		}
		p++;
	}
	if (flags) {
		if (*worker) {
			memcpy(worker, " | ", 4);
			worker += 3;
		}
		sprintf(worker, "%04X", flags);
	}
	return *worker ? worker : "0";
}

void Dbg_TraceExtTextOutW(int nXStart, int nYStart, UINT fuOptions, LPCWSTR lpString, int cbString, const int* lpDx)
{
	LPWSTR p = (LPWSTR)_alloca((cbString + 1) * sizeof(WCHAR));
	memcpy(p, lpString, cbString * sizeof(WCHAR));
	p[cbString] = 0;

	static const FLAG_NAME_MAP c_map[] = {
		DEF_FLAG_NAME(ETO_OPAQUE, ETO_OPAQUE, 0),
		DEF_FLAG_NAME(ETO_CLIPPED, ETO_CLIPPED, 0),
		DEF_FLAG_NAME(ETO_GLYPH_INDEX, ETO_GLYPH_INDEX, 0),
		DEF_FLAG_NAME(ETO_RTLREADING, ETO_RTLREADING, 0),
		DEF_FLAG_NAME(ETO_NUMERICSLOCAL, ETO_NUMERICSLOCAL, 0),
		DEF_FLAG_NAME(ETO_NUMERICSLATIN, ETO_NUMERICSLATIN, 0),
		DEF_FLAG_NAME(ETO_IGNORELANGUAGE, ETO_IGNORELANGUAGE, 0),
		DEF_FLAG_NAME(ETO_PDY, ETO_PDY, 0),
	};
	CHAR wk[1024];
	TRACE(_T("ExtTextOutW(%d, %d, %hs, \"%ls\", %d, %hs)\n")
			, nXStart, nYStart, Dbg_GetFlagNames(fuOptions, c_map, wk), p, cbString, lpDx ? "{...}" : "NULL");
}

void Dbg_TractGetTextExtent(LPCSTR lpString, int cbString, LPSIZE lpSize)
{
	LPSTR p = (LPSTR)_alloca((cbString + 1) * sizeof(CHAR));
	memcpy(p, lpString, cbString * sizeof(CHAR));
	p[cbString] = 0;
	TRACE(_T("GetTextExtentA(\"%hs\", %d) = { %d, %d }\n")
			, p, cbString, lpSize->cx, lpSize->cy);
}

void Dbg_TractGetTextExtent(LPCWSTR lpString, int cbString, LPSIZE lpSize)
{
	LPWSTR p = (LPWSTR)_alloca((cbString + 1) * sizeof(WCHAR));
	memcpy(p, lpString, cbString * sizeof(WCHAR));
	p[cbString] = 0;
	TRACE(_T("GetTextExtentW(\"%ls\", %d) = { %d, %d }\n")
			, p, cbString, lpSize->cx, lpSize->cy);
}
#endif
